const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geral = new Helper.geral();
const loginPage = new Helper.login();
const rotaPage = require('../../../page-objects/parametrizacao/expedicao/rotaDeEntrega.po.js');
const j = require('../../../json/leitorJson.po.js');
const protractorHelper = require('protractor-helper');

const rotaDeEntregaGridId = '23853047230212150612762';
describe('Tela Rota de Entrega', () => {
	beforeAll(() => {
		loginPage.login(j.getValor('login'), j.getValor('senha'));
		rotaPage.abrir();
	});

	afterAll(() => {
		geral.sair();
	});

	it('Deve acessar a tela Rota de Entrega', () => {
		expect(z.component.header.getTitle()).toBe('Rota de Entrega');
	});

	it('Deve adicionar uma rota de entrega', () => {
		geral.clickAdicionar();
		rotaPage.adicionar(j.getValor('codigoRota'), j.getValor('nomeRota'));
		geral.clickSalvar();
		geral.esperarLoading();
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${rotaDeEntregaGridId}`)));
		browser.sleep(2000);

		expect(geral.gridHasText(rotaDeEntregaGridId, j.getValor('nomeRota'), 1))
			.toBe(j.getValor('nomeRota'));
	});

	it('Deve adicionar um município', () => {
		geral.clickGrid('CDROTATRANS', j.getValor('codigoRota'), rotaDeEntregaGridId);
		geral.trocarAba('Município por Rota');
		geral.clickAdicionar();
		rotaPage.adicionarMunicipio(j.getValor('pais'), j.getValor('estado'),
			j.getValor('municipio'), j.getValor('bairro'), j.getValor('valorFrete'));
		geral.clickSalvar();
		geral.esperarLoading();
		protractorHelper.waitForElementVisibility(element(by.id('grid-2385304728596984542763')));

		expect(geral.gridHasText('2385304728596984542763', j.getValor('valorFrete'), 4))
			.toBe(j.getValor('valorFrete'));
	});

	it('Deve adicionar um cliente por rota', () => {
		geral.trocarAba('Cliente por Rota');
		geral.clickAdicionar();
		rotaPage.adicionarCliente(j.getValor('ordem'), j.getValor('nomeCliente'),
			j.getValor('enderecoCliente'), j.getValor('cepCliente'));
		geral.clickSalvar();
		geral.esperarLoading();
		protractorHelper.waitForElementVisibility(element(by.id('grid-23853047220498999152796')));

		expect(geral.gridHasText('23853047220498999152796', j.getValor('ordem')))
			.toBe(j.getValor('ordem'));
	});

	it('Deve adicionar uma filial', () => {
		geral.trocarAba('Cliente por Rota');
		geral.clickAdicionar();
		rotaPage.adicionarFilial(j.getValor('ordem'), j.getValor('codigoFilial'), j.getValor('nomeFilial'), j.getValor('enderecoFilial'), j.getValor('cepFilial'));
		geral.clickSalvar();
		geral.esperarLoading();
		protractorHelper.waitForElementVisibility(element(by.id('grid-23853047211559924372819')));

		expect(geral.gridHasText('23853047211559924372819', j.getValor('ordem')))
			.toBe(j.getValor('ordem'));
	});

	it('Alterar rota de entrega', () => {
		geral.trocarAba('Rota de Entrega');
		geral.clickEditar();
		geral.fillField('NMROTATRANS', j.getValor('nomeRota1'));
		geral.clickSalvar();
		geral.clickVoltar();
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${rotaDeEntregaGridId}`)));

		expect(geral.gridHasText(rotaDeEntregaGridId, j.getValor('nomeRota1'), 1))
			.toBe(j.getValor('nomeRota1'));
	});

	it('Excluir Rota de Entrega', () => {
		geral.clickGrid('CDROTATRANS', j.getValor('codigoRota'), rotaDeEntregaGridId);
		geral.clickExcluir();
		z.component.footer.clickCenterActionByLabel('Deletar');
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${rotaDeEntregaGridId}`)));

		expect(geral.gridHasText(rotaDeEntregaGridId, j.getValor('nomeRota1'), 1))
			.toBeUndefined();
	});
});
